* class.c (create_vtable_ptr): Put the vtable at the beginning of
[official-gcc.git] / configure.in
blob5b154f58e5a043c04f2a7d26da73363cd0d88c9b
1 #! /bin/bash
2 ##############################################################################
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
17 # Copyright (C) 1992, 93, 94, 95, 96, 97, 1998, 1999 Free Software Foundation, Inc.
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
33 ##############################################################################
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
42 # these libraries are used by various programs built for the host environment
44 host_libs="intl mmalloc libiberty opcodes bfd readline gash db tcl tk tclX itcl tix libgui"
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
50 # these tools are built for the host environment
51 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
52 # know that we are building the simulator.
53 host_tools="texinfo byacc flex bison binutils ld gas gcc sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu ash bash bzip2 m4 autoconf automake libtool ispell grep diff rcs cvssrc fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils snavigator libtool gettext zip"
56 # these libraries are built for the target environment, and are built after
57 # the host libraries and the host tools (which may be a cross compiler)
59 target_libs="target-libiberty \
60 target-libgloss \
61 target-newlib \
62 target-libio \
63 target-librx \
64 target-libstdc++ \
65 target-libg++ \
66 target-libf2c \
67 target-libchill \
68 target-libjava \
69 target-zlib \
70 target-boehm-gc \
71 target-qthreads \
72 target-libobjc"
74 # these tools are built using the target libs, and are intended to run only
75 # in the target environment
77 # note: any program that *uses* libraries that are in the "target_libs"
78 # list belongs in this list. those programs are also very likely
79 # candidates for the "native_only" list which follows
81 target_tools="target-examples target-groff target-gperf"
83 ################################################################################
85 ## These two lists are of directories that are to be removed from the
86 ## ${configdirs} list for either cross-compilations or for native-
87 ## compilations. For example, it doesn't make that much sense to
88 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
89 ## a native environment.
91 # directories to be built in the native environment only
93 # This must be a single line because of the way it is searched by grep in
94 # the code below.
95 native_only="autoconf automake libtool cvssrc emacs emacs19 fileutils find gawk gettext grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time ash bash bzip2 prms snavigator gnuserv target-gperf"
97 # directories to be built in a cross environment only
99 cross_only="target-libgloss target-newlib target-cygmon target-opcodes target-libstub"
101 ## All tools belong in one of the four categories, and are assigned above
102 ## We assign ${configdirs} this way to remove all embedded newlines. This
103 ## is important because configure will choke if they ever get through.
104 ## ${configdirs} is directories we build using the host tools.
105 ## ${target_configdirs} is directories we build using the target tools.
107 configdirs=`echo ${host_libs} ${host_tools}`
108 target_configdirs=`echo ${target_libs} ${target_tools}`
110 ################################################################################
112 srctrigger=move-if-change
113 srcname="gnu development package"
115 # This gets set non-empty for some net releases of packages.
116 appdirs=""
118 # per-host:
120 # Work in distributions that contain no compiler tools, like Autoconf.
121 if [ -d ${srcdir}/config ]; then
122 case "${host}" in
123 m68k-hp-hpux*)
124 host_makefile_frag="${host_makefile_frag} config/mh-hp300"
126 m68k-apollo-sysv*)
127 host_makefile_frag="${host_makefile_frag} config/mh-apollo68"
129 m68k-apollo-bsd*)
130 host_makefile_frag="${host_makefile_frag} config/mh-a68bsd"
132 m88k-dg-dgux*)
133 host_makefile_frag="${host_makefile_frag} config/mh-dgux"
135 m88k-harris-cxux*)
136 host_makefile_frag="${host_makefile_frag} config/mh-cxux"
138 m88k-motorola-sysv*)
139 host_makefile_frag="${host_makefile_frag} config/mh-delta88"
141 mips*-dec-ultrix*)
142 host_makefile_frag="${host_makefile_frag} config/mh-decstation"
144 mips*-nec-sysv4*)
145 host_makefile_frag="${host_makefile_frag} config/mh-necv4"
147 mips*-sgi-irix6*)
148 host_makefile_frag="${host_makefile_frag} config/mh-irix6"
150 mips*-sgi-irix5*)
151 host_makefile_frag="${host_makefile_frag} config/mh-irix5"
153 mips*-sgi-irix4*)
154 host_makefile_frag="${host_makefile_frag} config/mh-irix4"
156 mips*-sgi-irix3*)
157 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
159 mips*-*-sysv4*)
160 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
162 mips*-*-sysv*)
163 host_makefile_frag="${host_makefile_frag} config/mh-riscos"
165 i370-ibm-opened*)
166 host_makefile_frag="${host_makefile_frag} config/mh-openedition"
168 i[3456]86-*-sysv5*)
169 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
171 i[3456]86-*-dgux*)
172 host_makefile_frag="${host_makefile_frag} config/mh-dgux386"
174 i[3456]86-ncr-sysv4.3*)
175 host_makefile_frag="${host_makefile_frag} config/mh-ncrsvr43"
177 i[3456]86-ncr-sysv4*)
178 host_makefile_frag="${host_makefile_frag} config/mh-ncr3000"
180 i[3456]86-*-sco3.2v5*)
181 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
183 i[3456]86-*-sco*)
184 host_makefile_frag="${host_makefile_frag} config/mh-sco"
186 i[3456]86-*-udk*)
187 host_makefile_frag="${host_makefile_frag} config/mh-sysv5"
189 i[3456]86-*-isc*)
190 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
192 i[3456]86-*-solaris2*)
193 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
195 i[3456]86-*-aix*)
196 host_makefile_frag="${host_makefile_frag} config/mh-aix386"
198 i[3456]86-*-msdosdjgpp*)
199 host_makefile_frag="${host_makefile_frag} config/mh-djgpp"
201 *-cygwin32*)
202 host_makefile_frag="${host_makefile_frag} config/mh-cygwin"
204 *-mingw32*)
205 host_makefile_frag="${host_makefile_frag} config/mh-mingw32"
207 *-interix*)
208 host_makefile_frag="${host_makefile_frag} config/mh-interix"
210 *-windows*)
211 host_makefile_frag="${host_makefile_frag} config/mh-windows"
213 vax-*-ultrix2*)
214 host_makefile_frag="${host_makefile_frag} config/mh-vaxult2"
216 *-*-solaris2*)
217 host_makefile_frag="${host_makefile_frag} config/mh-solaris"
219 m68k-sun-sunos*)
220 host_makefile_frag="${host_makefile_frag} config/mh-sun3"
222 *-hp-hpux[78]*)
223 host_makefile_frag="${host_makefile_frag} config/mh-hpux8"
225 *-hp-hpux*)
226 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
228 *-*-hiux*)
229 host_makefile_frag="${host_makefile_frag} config/mh-hpux"
231 rs6000-*-lynxos*)
232 host_makefile_frag="${host_makefile_frag} config/mh-lynxrs6k"
234 *-*-lynxos*)
235 host_makefile_frag="${host_makefile_frag} config/mh-lynxos"
237 *-*-aix4.[3456789]* | *-*-aix[56789].*)
238 host_makefile_frag="${host_makefile_frag} config/mh-aix43"
240 *-*-sysv4*)
241 host_makefile_frag="${host_makefile_frag} config/mh-sysv4"
243 *-*-sysv*)
244 host_makefile_frag="${host_makefile_frag} config/mh-sysv"
246 esac
249 # If we aren't going to be using gcc, see if we can extract a definition
250 # of CC from the fragment.
251 if [ -z "${CC}" ] && [ "${build}" = "${host}" ]; then
252 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
253 found=
254 for dir in $PATH; do
255 test -z "$dir" && dir=.
256 if test -f $dir/gcc; then
257 found=yes
258 break
260 done
261 IFS="$save_ifs"
262 if [ -z "${found}" ] && [ -n "${host_makefile_frag}" ] && [ -f "${srcdir}/${host_makefile_frag}" ]; then
263 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
264 if [ -n "${xx}" ] ; then
265 CC=$xx
270 # We default to --with-shared on platforms where -fpic is meaningless.
271 # Well, we don't yet, but we will.
272 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
273 case "${target}" in
274 alpha*-dec-osf*) enable_shared=yes ;;
275 alpha*-*-linux*) enable_shared=yes ;;
276 mips-sgi-irix5*) enable_shared=yes ;;
277 *) enable_shared=no ;;
278 esac
281 case "${enable_shared}" in
282 yes) shared=yes ;;
283 no) shared=no ;;
284 "") shared=no ;;
285 *) shared=yes ;;
286 esac
288 if [ x${shared} = xyes ]; then
289 case "${host}" in
290 alpha*-*-linux*)
291 host_makefile_frag="${host_makefile_frag} config/mh-elfalphapic"
293 arm*-*-*)
294 host_makefile_frag="${host_makefile_frag} config/mh-armpic"
296 hppa*-*-*)
297 host_makefile_frag="${host_makefile_frag} config/mh-papic"
299 i[3456]86-*-cygwin32*)
300 # We don't want -fPIC on cygwin32.
302 i[3456]86-*-*)
303 host_makefile_frag="${host_makefile_frag} config/mh-x86pic"
305 sparc64-*-*)
306 host_makefile_frag="${host_makefile_frag} config/mh-sparcpic"
308 powerpc*-*-aix*)
309 # We don't want -fPIC on AIX.
311 powerpc*-*-*)
312 host_makefile_frag="${host_makefile_frag} config/mh-ppcpic"
314 *-*-*)
315 if test -f ${srcdir}/config/mh-${host_cpu}pic; then
316 host_makefile_frag="${host_makefile_frag} config/mh-${host_cpu}pic"
319 esac
322 rm -f mh-frag
323 if [ -n "${host_makefile_frag}" ] ; then
324 for f in ${host_makefile_frag}
326 cat ${srcdir}/$f >> mh-frag
327 done
328 host_makefile_frag=mh-frag
331 # per-target:
333 case "${target}" in
334 v810*)
335 target_makefile_frag="${target_makefile_frag} config/mt-v810"
337 i[3456]86-*-netware*)
338 target_makefile_frag="${target_makefile_frag} config/mt-netware"
340 powerpc-*-netware*)
341 target_makefile_frag="${target_makefile_frag} config/mt-netware"
343 *-*-linux-gnu)
344 target_makefile_frag="${target_makefile_frag} config/mt-linux"
346 esac
348 # If --enable-target-optspace always use -Os instead of -O2 to build
349 # the target libraries, similarly if it is not specified, use -Os
350 # on selected platforms.
351 case "${enable_target_optspace}:${target}" in
352 yes:*)
353 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
355 :m32r-* | :fr30-*)
356 target_makefile_frag="${target_makefile_frag} config/mt-ospace"
358 no:* | :*)
361 echo "*** bad value \"${enable_target_optspace}\" for --enable-target-optspace flag; ignored" 1>&2
363 esac
365 skipdirs=
366 gasdir=gas
367 use_gnu_ld=
368 use_gnu_as=
370 # some tools are so dependent upon X11 that if we're not building with X,
371 # it's not even worth trying to configure, much less build, that tool.
373 case ${with_x} in
374 yes | "") # the default value for this tree is that X11 is available
377 skipdirs="${skipdirs} tk libgui gash"
380 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
382 esac
384 # Some tools are only suitable for building in a "native" situation.
385 # Those are added when we have a host==target configuration. For cross
386 # toolchains, we add some directories that should only be useful in a
387 # cross-compiler.
389 is_cross_compiler=
391 if [ x"${host}" = x"${target}" ] ; then
392 # when doing a native toolchain, don't build the targets
393 # that are in the 'cross only' list
394 skipdirs="${skipdirs} ${cross_only}"
395 is_cross_compiler=no
396 else
397 # similarly, don't build the targets in the 'native only'
398 # list when building a cross compiler
399 skipdirs="${skipdirs} ${native_only}"
400 is_cross_compiler=yes
403 # We always want to use the same name for this directory, so that dejagnu
404 # can reliably find it.
405 target_subdir=${target_alias}
407 if [ ! -d ${target_subdir} ] ; then
408 if mkdir ${target_subdir} ; then true
409 else
410 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
411 exit 1
415 copy_dirs=
417 # Handle --with-headers=XXX. The contents of the named directory are
418 # copied to $(tooldir)/sys-include.
419 if [ x"${with_headers}" != x ]; then
420 if [ x${is_cross_compiler} = xno ]; then
421 echo 1>&2 '***' --with-headers is only supported when cross compiling
422 exit 1
424 case "${exec_prefixoption}" in
425 "") x=${prefix} ;;
426 *) x=${exec_prefix} ;;
427 esac
428 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
431 # Handle --with-libs=XXX. Multiple directories are permitted. The
432 # contents are copied to $(tooldir)/lib.
433 if [ x"${with_libs}" != x ]; then
434 if [ x${is_cross_compiler} = xno ]; then
435 echo 1>&2 '***' --with-libs is only supported when cross compiling
436 exit 1
438 # Copy the libraries in reverse order, so that files in the first named
439 # library override files in subsequent libraries.
440 case "${exec_prefixoption}" in
441 "") x=${prefix} ;;
442 *) x=${exec_prefix} ;;
443 esac
444 for l in ${with_libs}; do
445 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
446 done
449 # If both --with-headers and --with-libs are specified, default to
450 # --without-newlib.
451 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
452 if [ x"${with_newlib}" = x ]; then
453 with_newlib=no
457 # Recognize --with-newlib/--without-newlib.
458 if [ x${with_newlib} = xno ]; then
459 skipdirs="${skipdirs} target-newlib"
460 elif [ x${with_newlib} = xyes ]; then
461 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
464 # Default to using --with-stabs for certain targets.
465 if [ x${with_stabs} = x ]; then
466 case "${target}" in
467 mips*-*-irix6*)
469 mips*-*-* | alpha*-*-osf*)
470 with_stabs=yes;
471 withoptions="${withoptions} --with-stabs"
473 esac
476 # Handle ${copy_dirs}
477 set fnord ${copy_dirs}
478 shift
479 while [ $# != 0 ]; do
480 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
482 else
483 echo Copying $1 to $2
485 # Use the install script to create the directory and all required
486 # parent directories.
487 if [ -d $2 ]; then
489 else
490 echo >config.temp
491 ${srcdir}/install-sh -c -m 644 config.temp $2/COPIED
494 # Copy the directory, assuming we have tar.
495 # FIXME: Should we use B in the second tar? Not all systems support it.
496 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
498 # It is the responsibility of the user to correctly adjust all
499 # symlinks. If somebody can figure out how to handle them correctly
500 # here, feel free to add the code.
502 echo $1 > $2/COPIED
504 shift; shift
505 done
507 # Configure extra directories which are host specific
509 case "${host}" in
510 i[3456]86-*-go32*)
511 configdirs="$configdirs dosrel" ;;
512 i[3456]86-*-mingw32*)
513 configdirs="$configdirs dosrel" ;;
514 *-cygwin32*)
515 configdirs="$configdirs dosrel" ;;
516 esac
518 # Remove more programs from consideration, based on the host or
519 # target this usually means that a port of the program doesn't
520 # exist yet.
522 noconfigdirs=""
524 case "${host}" in
525 i[3456]86-*-vsta)
526 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
528 i[3456]86-*-go32* | i[3456]86-*-msdosdjgpp*)
529 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv gettext"
531 i[3456]86-*-mingw32*)
532 # noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db snavigator gnuserv"
533 noconfigdirs="expect dejagnu cvs autoconf automake send-pr gprof rcs guile perl texinfo apache inet libtool"
535 *-*-cygwin32)
536 noconfigdirs="autoconf automake send-pr gprof rcs guile perl apache inet"
538 *-*-windows*)
539 # This is only used to build WinGDB...
540 # note that powerpc-eabi depends on sim configured before gdb.
541 configdirs="bfd libiberty opcodes readline sim gdb"
542 target_configdirs=
544 *-*-netbsd*)
545 noconfigdirs="rcs"
547 ppc*-*-pe)
548 noconfigdirs="patch diff make tk tcl expect dejagnu cvssrc autoconf automake texinfo bison send-pr gprof rcs guile perl apache inet itcl tix db snavigator gnuserv"
550 esac
553 case "${target}" in
554 *-*-netware)
555 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
557 *-*-rtems*)
558 noconfigdirs="$noconfigdirs target-libgloss"
560 *-*-vxworks*)
561 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
563 alpha*-dec-osf*)
564 # ld works, but does not support shared libraries. emacs doesn't
565 # work. newlib is not 64 bit ready. I'm not sure about fileutils.
566 # gas doesn't generate exception information.
567 noconfigdirs="$noconfigdirs gas ld emacs fileutils target-newlib target-libgloss"
569 alpha*-*-*vms*)
570 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
572 alpha*-*-linux*)
573 # newlib is not 64 bit ready
574 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
575 # linux has rx in libc
576 skipdirs="$skipdirs target-librx"
578 alpha*-*-*)
579 # newlib is not 64 bit ready
580 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
582 arc-*-*)
583 noconfigdirs="$noconfigdirs target-libgloss"
585 arm-*-pe*)
586 noconfigdirs="$noconfigdirs target-libgloss"
588 arm-*-coff*)
589 noconfigdirs="$noconfigdirs target-libgloss"
591 arm-*-elf*)
592 noconfigdirs="$noconfigdirs target-libgloss"
593 if [ x${is_cross_compiler} != xno ] ; then
594 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
597 arm-*-oabi*)
598 noconfigdirs="$noconfigdirs target-libgloss"
599 if [ x${is_cross_compiler} != xno ] ; then
600 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
603 c4x-*-*)
604 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
606 thumb-*-coff)
607 noconfigdirs="$noconfigdirs target-libgloss"
609 arm-*-riscix*)
610 noconfigdirs="$noconfigdirs ld target-libgloss"
612 d10v-*-*)
613 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
615 fr30-*-elf*)
616 if [ x${is_cross_compiler} != xno ] ; then
617 target_configdirs="${target_configdirs} target-bsp target-libstub target-cygmon"
620 h8300*-*-* | \
621 h8500-*-*)
622 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
624 hppa*-*-*elf* | \
625 hppa*-*-lites*)
626 # Do configure ld/binutils/gas for this case.
628 hppa*-*-*)
629 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
630 # cc is gcc, and on any system a user should be able to link cc to
631 # whatever they want. FIXME, emacs emacs19).
632 case "${CC}" in
633 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
634 *) ;;
635 esac
636 noconfigdirs="$noconfigdirs ld shellutils"
638 i[3456]86-*-go32* | i[3456]-*-msdosdjgpp*)
639 # but don't build gdb
640 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
642 *-*-linux*)
643 # linux has rx in libc
644 skipdirs="$skipdirs target-librx"
646 i[3456]86-*-mingw32*)
647 target_configdirs="$target_configdirs target-mingw"
648 noconfigdirs="$noconfigdirs expect target-libgloss"
650 # Can't build gdb for mingw32 if not native.
651 case "${host}" in
652 i[3456]86-*-mingw32) ;; # keep gdb tcl tk expect etc.
653 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix db snavigator gnuserv"
655 esac
657 *-*-cygwin32*)
658 target_configdirs="$target_configdirs target-winsup"
659 noconfigdirs="$noconfigdirs target-gperf target-libgloss"
660 # always build newlib.
661 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
663 # Can't build gdb for cygwin32 if not native.
664 case "${host}" in
665 *-*-cygwin32*) ;; # keep gdb tcl tk expect etc.
666 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix libgui db snavigator gnuserv"
668 esac
670 i[3456]86-*-pe)
671 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
673 i[3456]86-*-sco3.2v5*)
674 # The linker does not yet know about weak symbols in COFF,
675 # and is not configured to handle mixed ELF and COFF.
676 noconfigdirs="$noconfigdirs ld target-libgloss"
678 i[3456]86-*-sco*)
679 noconfigdirs="$noconfigdirs gprof target-libgloss"
681 i[3456]86-*-solaris2*)
682 # The linker does static linking correctly, but the Solaris C library
683 # has bugs such that some important functions won't work when statically
684 # linked. (See man pages for getpwuid, for example.)
685 noconfigdirs="$noconfigdirs ld target-libgloss"
687 i[3456]86-*-sysv4*)
688 # The SYSV4 C compiler doesn't handle Emacs correctly
689 case "${CC}" in
690 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
691 *) ;;
692 esac
693 # but that's okay since emacs doesn't work anyway
694 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
696 mn10200-*-*)
697 noconfigdirs="$noconfigdirs"
698 if [ x${is_cross_compiler} != xno ] ; then
699 target_configdirs="${target_configdirs} target-libstub target-cygmon"
702 mn10300-*-*)
703 noconfigdirs="$noconfigdirs"
704 if [ x${is_cross_compiler} != xno ] ; then
705 target_configdirs="${target_configdirs} target-libstub target-cygmon"
708 powerpc-*-aix*)
709 # copied from rs6000-*-* entry
710 # The configure and build of ld are currently disabled because
711 # GNU ld is known to be broken for AIX 4.2 and 4.3 (at least)
712 # The symptom is that GDBtk 4.18 fails at startup with a segfault
713 # if linked by GNU ld, but not if linked by the native ld.
714 noconfigdirs="$noconfigdirs gprof cvssrc target-libgloss ld"
715 use_gnu_ld=no
717 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
718 target_configdirs="$target_configdirs target-winsup"
719 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl tix db snavigator gnuserv"
720 # always build newlib.
721 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
723 # This is temporary until we can link against shared libraries
724 powerpcle-*-solaris*)
725 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl tix db snavigator gnuserv"
727 rs6000-*-lynxos*)
728 # The CVS server code doesn't work on the RS/6000
729 # Newlib makes problems for libg++ in crosses.
730 noconfigdirs="$noconfigdirs target-newlib gprof cvssrc"
732 rs6000-*-aix*)
733 # The configure and build of ld are currently disabled because
734 # GNU ld is known to be broken for AIX 4.2 and 4.3 (at least)
735 # The symptom is that GDBtk 4.18 fails at startup with a segfault
736 # if linked by GNU ld, but not if linked by the native ld.
737 noconfigdirs="$noconfigdirs gprof ld"
738 use_gnu_ld=no
740 rs6000-*-*)
741 noconfigdirs="$noconfigdirs gprof"
743 m68k-apollo-*)
744 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
746 mips*-*-irix5*)
747 # The GNU linker does not support shared libraries.
748 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
749 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
751 mips*-*-irix6*)
752 # The GNU assembler and linker do not support IRIX 6.
753 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
754 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
756 mips*-dec-bsd*)
757 noconfigdirs="$noconfigdirs gprof target-libgloss"
759 mips*-*-bsd*)
760 noconfigdirs="$noconfigdirs gprof target-libgloss"
762 mipstx39-*-*)
763 noconfigdirs="$noconfigdirs gprof" # same as generic mips
764 target_configdirs="${target_configdirs} target-libstub target-cygmon"
766 mips*-*-*)
767 noconfigdirs="$noconfigdirs gprof"
769 romp-*-*)
770 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
772 sh-*-*)
773 case "${host}" in
774 i[3456]86-*-vsta) ;; # don't add gprof back in
775 i[3456]86-*-go32*) ;; # don't add gprof back in
776 i[3456]86-*-msdosdjgpp*) ;; # don't add gprof back in
777 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
778 esac
779 noconfigdirs="$noconfigdirs target-libgloss"
781 sparc-*-elf*)
782 if [ x${is_cross_compiler} != xno ] ; then
783 target_configdirs="${target_configdirs} target-libstub target-cygmon"
786 sparc64-*-elf*)
787 if [ x${is_cross_compiler} != xno ] ; then
788 target_configdirs="${target_configdirs} target-libstub target-cygmon"
791 sparclite-*-aout*)
792 if [ x${is_cross_compiler} != xno ] ; then
793 target_configdirs="${target_configdirs} target-libstub target-cygmon"
796 sparc-*-sunos4*)
797 if [ x${is_cross_compiler} != xno ] ; then
798 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
799 else
800 use_gnu_ld=no
803 v810-*-*)
804 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
806 v850-*-*)
807 noconfigdirs="$noconfigdirs target-libgloss"
809 vax-*-vms)
810 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
812 vax-*-*)
813 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
815 *-*-lynxos*)
816 # Newlib makes problems for libg++ in crosses.
817 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
819 *-*-macos* | \
820 *-*-mpw*)
821 # Macs want a resource compiler.
822 configdirs="$configdirs grez"
824 esac
826 # If we aren't building newlib, then don't build libgloss, since libgloss
827 # depends upon some newlib header files.
828 case "${noconfigdirs}" in
829 *target-libgloss*) ;;
830 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
831 esac
833 # Make sure we don't let GNU ld be added if we didn't want it.
834 if [ x$with_gnu_ld = xno ]; then
835 use_gnu_ld=no
836 noconfigdirs="$noconfigdirs ld"
839 # Make sure we don't let GNU as be added if we didn't want it.
840 if [ x$with_gnu_as = xno ]; then
841 use_gnu_as=no
842 noconfigdirs="$noconfigdirs gas"
845 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
846 # $target_configdirs.
847 # If we have the source for $noconfigdirs entries, add them to $notsupp.
849 notsupp=""
850 for dir in . $skipdirs $noconfigdirs ; do
851 dirname=`echo $dir | sed -e s/target-//g`
852 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
853 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
854 if [ -r $srcdir/$dirname/configure ] \
855 || [ -r $srcdir/$dirname/configure.in ]; then
856 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
857 true
858 else
859 notsupp="$notsupp $dir"
863 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
864 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
865 if [ -r $srcdir/$dirname/configure ] \
866 || [ -r $srcdir/$dirname/configure.in ]; then
867 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
868 true
869 else
870 notsupp="$notsupp $dir"
874 done
876 # Sometimes the tools are distributed with libiberty but with no other
877 # libraries. In that case, we don't want to build target-libiberty.
878 if [ -n "${target_configdirs}" ]; then
879 others=
880 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
881 if [ "$i" != "libiberty" ]; then
882 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
883 others=yes;
884 break;
887 done
888 if [ -z "${others}" ]; then
889 target_configdirs=
893 # Deconfigure all subdirectories, in case we are changing the
894 # configuration from one where a subdirectory is supported to one where it
895 # is not.
896 if [ -z "${norecursion}" ] && [ -n "${configdirs}" ]; then
897 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
898 rm -f $i/Makefile
899 done
901 if [ -z "${norecursion}" ] && [ -n "${target_configdirs}" ]; then
902 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
903 rm -f ${target_subdir}/$i/Makefile
904 done
907 # Produce a warning message for the subdirs we can't configure.
908 # This isn't especially interesting in the Cygnus tree, but in the individual
909 # FSF releases, it's important to let people know when their machine isn't
910 # supported by the one or two programs in a package.
912 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
913 # If $appdirs is non-empty, at least one of those directories must still
914 # be configured, or we error out. (E.g., if the gas release supports a
915 # specified target in some subdirs but not the gas subdir, we shouldn't
916 # pretend that all is well.)
917 if [ -n "$appdirs" ]; then
918 for dir in $appdirs ; do
919 if [ -r $dir/Makefile.in ]; then
920 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
921 appdirs=""
922 break
924 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
925 appdirs=""
926 break
929 done
930 if [ -n "$appdirs" ]; then
931 echo "*** This configuration is not supported by this package." 1>&2
932 exit 1
935 # Okay, some application will build, or we don't care to check. Still
936 # notify of subdirs not getting built.
937 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
938 echo " ${notsupp}" 1>&2
939 echo " (Any other directories should still work fine.)" 1>&2
942 # Set with_gnu_as and with_gnu_ld as appropriate.
944 # This is done by determining whether or not the appropriate directory
945 # is available, and by checking whether or not specific configurations
946 # have requested that this magic not happen.
948 # The command line options always override the explicit settings in
949 # configure.in, and the settings in configure.in override this magic.
951 # If the default for a toolchain is to use GNU as and ld, and you don't
952 # want to do that, then you should use the --without-gnu-as and
953 # --without-gnu-ld options for the configure script.
955 if [ x${use_gnu_as} = x ] ; then
956 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
957 with_gnu_as=yes
958 withoptions="$withoptions --with-gnu-as"
962 if [ x${use_gnu_ld} = x ] ; then
963 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
964 with_gnu_ld=yes
965 withoptions="$withoptions --with-gnu-ld"
969 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
970 # can detect this case.
972 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
973 with_newlib=yes
974 withoptions="$withoptions --with-newlib"
977 if [ x${shared} = xyes ]; then
978 case "${target}" in
979 hppa*)
980 target_makefile_frag="${target_makefile_frag} config/mt-papic"
982 i[3456]86-*)
983 target_makefile_frag="${target_makefile_frag} config/mt-x86pic"
985 powerpc*-*)
986 target_makefile_frag="${target_makefile_frag} config/mt-ppcpic"
988 alpha*-*-linux*)
989 target_makefile_frag="${target_makefile_frag} config/mt-elfalphapic"
992 if test -f ${srcdir}/config/mt-${target_cpu}pic; then
993 target_makefile_frag="${target_makefile_frag} config/mt-${target_cpu}pic"
996 esac
999 rm -f mt-frag
1000 if [ -n "${target_makefile_frag}" ] ; then
1001 for f in ${target_makefile_frag}
1003 cat ${srcdir}/$f >> mt-frag
1004 done
1005 target_makefile_frag=mt-frag
1008 # post-target:
1010 # Make sure that the compiler is able to generate an executable. If it
1011 # can't, we are probably in trouble. We don't care whether we can run the
1012 # executable--we might be using a cross compiler--we only care whether it
1013 # can be created. At this point the main configure script has set CC.
1014 echo "int main () { return 0; }" > conftest.c
1015 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
1016 if [ $? = 0 ] && [ -s conftest -o -s conftest.exe ]; then
1018 else
1019 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
1020 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
1021 rm -f conftest*
1022 exit 1
1024 rm -f conftest*
1026 # The Solaris /usr/ucb/cc compiler does not appear to work.
1027 case "${host}" in
1028 sparc-sun-solaris2*)
1029 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
1030 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
1031 could_use=
1032 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
1033 if [ -d /opt/cygnus/bin ] ; then
1034 if [ "$could_use" = "" ] ; then
1035 could_use="/opt/cygnus/bin"
1036 else
1037 could_use="$could_use or /opt/cygnus/bin"
1040 if [ "$could_use" = "" ] ; then
1041 echo "Warning: compilation may fail because you're using"
1042 echo "/usr/ucb/cc. You should change your PATH or CC "
1043 echo "variable and rerun configure."
1044 else
1045 echo "Warning: compilation may fail because you're using"
1046 echo "/usr/ucb/cc, when you should use the C compiler from"
1047 echo "$could_use. You should change your"
1048 echo "PATH or CC variable and rerun configure."
1052 esac
1054 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
1055 # binutils tools will find libbfd.so.
1056 if [ "${shared}" = "yes" ]; then
1057 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
1058 Makefile > Makefile.tem
1059 rm -f Makefile
1060 mv -f Makefile.tem Makefile
1062 case "${host}" in
1063 *-*-hpux*)
1064 sed -e 's/^RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
1065 Makefile > Makefile.tem
1066 rm -f Makefile
1067 mv -f Makefile.tem Makefile
1069 esac
1072 # Record target_configdirs and the configure arguments in Makefile.
1073 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
1074 targargs=`echo "${arguments}" | \
1075 sed -e 's/--no[^ ]*//' \
1076 -e 's/--cache[a-z-]*=[^ ]*//' \
1077 -e 's/--ho[a-z-]*=[^ ]*//' \
1078 -e 's/--bu[a-z-]*=[^ ]*//' \
1079 -e 's/--ta[a-z-]*=[^ ]*//'`
1081 # Passing a --with-cross-host argument lets the target libraries know
1082 # whether they are being built with a cross-compiler or being built
1083 # native. However, it would be better to use other mechanisms to make the
1084 # sorts of decisions they want to make on this basis. Please consider
1085 # this option to be deprecated. FIXME.
1086 if [ x${is_cross_compiler} = xyes ]; then
1087 targargs="--with-cross-host=${host_alias} ${targargs}"
1090 # Default to --enable-multilib.
1091 if [ x${enable_multilib} = x ]; then
1092 targargs="--enable-multilib ${targargs}"
1095 # Pass --with-newlib if appropriate. Note that target_configdirs has
1096 # changed from the earlier setting of with_newlib.
1097 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
1098 targargs="--with-newlib ${targargs}"
1101 # provide a proper gxx_include_dir.
1102 # Note, if you change the default, make sure to fix both here and in
1103 # the gcc, libio, libstdc++ and libg++ subdirectories.
1104 # Check whether --with-gxx-include-dir or --without-gxx-include-dir was given.
1105 gxx_include_dir=
1106 if test -n "${with_gxx_include_dir}"; then
1107 case "${with_gxx_include_dir}" in
1108 yes )
1109 echo "configure.in: error: bad value ${withval} given for g++ include directory" 1>&2
1110 exit 1
1112 no )
1115 gxx_include_dir=${with_gxx_include_dir}
1117 esac
1119 if test x${gxx_include_dir} = x; then
1120 if test x${enable_version_specific_runtime_libs} = xyes; then
1121 gxx_include_dir='${libsubdir}/include/g++'
1122 else
1123 . ${topsrcdir}/config.if
1124 gxx_include_dir='${prefix}/include/g++'-${libstdcxx_interface}
1126 else
1127 gxx_include_dir=${gxx_include_dir}
1130 targargs="--host=${target_alias} --build=${build_alias} ${targargs}"
1131 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
1132 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
1133 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
1134 -e "s%^gxx_include_dir[ ]*=.*$%gxx_include_dir=${gxx_include_dir}%" \
1135 Makefile > Makefile.tem
1136 rm -f Makefile
1137 mv -f Makefile.tem Makefile
1140 # Local Variables:
1141 # fill-column: 131
1142 # End: